posedir = [databasedir, '/pose/p', traj, '/'];
out = [databasedir, traj, '/'];

suffix='robotpose.txt';
file = [posedir, suffix];
robotdata = dlmread(file, ',');
numframe = size(robotdata,1);
checkfile=[out,'checkrobot.txt'];
fid=fopen(checkfile,'w');

robotpose=convRobotData(robotdata);
robotpose(1:3,4,:)=robotpose(1:3,4,:)*1000;
figure;
rfig=scatter3(squeeze(robotpose(1,4,:)),squeeze(robotpose(2,4,:)),squeeze(robotpose(3,4,:)));
title('robotpose','fontsize',20);

fclose(fid);
saveas(mfig,[datadir,'robot_pose.fig']);
save([out,'robotpose.mat'], 'robotpose');